///////////////////////////////////////////////////////////////////////////
//                                                                       //
//            File: modem.h                                              //
//                  (project version).                                   //
//            started on: 23/2/92                                        //
//                                                                       //
///////////////////////////////////////////////////////////////////////////
//                                                                       //
//                                                                       //                                                                     //
///////////////////////////////////////////////////////////////////////////

#ifndef __MODEM_H
#define __MODEM_H

#include "serial.h" ; // SERIAL_PORT

class MODEM: public SERIAL_PORT {


public:
       MODEM(): SERIAL_PORT() {};
       ~MODEM();

       // this function is called when disconnecting from the modem.
       //
       virtual void disconnect(void);

       // overloads the msr_int from serial_port.
       //
       virtual void msr_int(const BYTE msr);

       // overloads the extended init.
       //
       virtual void extended_init();

       // overloads the flow control function.
       //
       virtual inline void flow_check();

       // called by msr_int when a ring is indicated.
       //
       virtual void ring_int(BYTE msr);

       // called by msr_int when a modem status is indicated (DSR, CTS).
       //
       virtual void modem_status_change(BYTE msr);

       // called by msr_int when DCD changes (up or down).
       //
       virtual void dcd_status_change(BYTE msr);

       // called to enquire as to the state of the modem.
       //
       BYTE get_MSR();

};

#endif
